// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/Item.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/item__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `uuid`
// Member `grasp_uuids`
// Member `type`
#include "rosidl_runtime_c/string_functions.h"
// Member `rectangle`
#include "rc_reason_msgs/msg/detail/rectangle__functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose_stamped__functions.h"

bool
rc_reason_msgs__msg__Item__init(rc_reason_msgs__msg__Item * msg)
{
  if (!msg) {
    return false;
  }
  // uuid
  if (!rosidl_runtime_c__String__init(&msg->uuid)) {
    rc_reason_msgs__msg__Item__fini(msg);
    return false;
  }
  // grasp_uuids
  if (!rosidl_runtime_c__String__Sequence__init(&msg->grasp_uuids, 0)) {
    rc_reason_msgs__msg__Item__fini(msg);
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__init(&msg->type)) {
    rc_reason_msgs__msg__Item__fini(msg);
    return false;
  }
  // rectangle
  if (!rc_reason_msgs__msg__Rectangle__init(&msg->rectangle)) {
    rc_reason_msgs__msg__Item__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__init(&msg->pose)) {
    rc_reason_msgs__msg__Item__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__msg__Item__fini(rc_reason_msgs__msg__Item * msg)
{
  if (!msg) {
    return;
  }
  // uuid
  rosidl_runtime_c__String__fini(&msg->uuid);
  // grasp_uuids
  rosidl_runtime_c__String__Sequence__fini(&msg->grasp_uuids);
  // type
  rosidl_runtime_c__String__fini(&msg->type);
  // rectangle
  rc_reason_msgs__msg__Rectangle__fini(&msg->rectangle);
  // pose
  geometry_msgs__msg__PoseStamped__fini(&msg->pose);
}

rc_reason_msgs__msg__Item *
rc_reason_msgs__msg__Item__create()
{
  rc_reason_msgs__msg__Item * msg = (rc_reason_msgs__msg__Item *)malloc(sizeof(rc_reason_msgs__msg__Item));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__Item));
  bool success = rc_reason_msgs__msg__Item__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__Item__destroy(rc_reason_msgs__msg__Item * msg)
{
  if (msg) {
    rc_reason_msgs__msg__Item__fini(msg);
  }
  free(msg);
}


bool
rc_reason_msgs__msg__Item__Sequence__init(rc_reason_msgs__msg__Item__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_reason_msgs__msg__Item * data = NULL;
  if (size) {
    data = (rc_reason_msgs__msg__Item *)calloc(size, sizeof(rc_reason_msgs__msg__Item));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__Item__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__Item__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__Item__Sequence__fini(rc_reason_msgs__msg__Item__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__Item__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__Item__Sequence *
rc_reason_msgs__msg__Item__Sequence__create(size_t size)
{
  rc_reason_msgs__msg__Item__Sequence * array = (rc_reason_msgs__msg__Item__Sequence *)malloc(sizeof(rc_reason_msgs__msg__Item__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__Item__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__Item__Sequence__destroy(rc_reason_msgs__msg__Item__Sequence * array)
{
  if (array) {
    rc_reason_msgs__msg__Item__Sequence__fini(array);
  }
  free(array);
}
