// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/SuctionGrasp.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/suction_grasp__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `uuid`
// Member `item_uuid`
#include "rosidl_runtime_c/string_functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose_stamped__functions.h"

bool
rc_reason_msgs__msg__SuctionGrasp__init(rc_reason_msgs__msg__SuctionGrasp * msg)
{
  if (!msg) {
    return false;
  }
  // uuid
  if (!rosidl_runtime_c__String__init(&msg->uuid)) {
    rc_reason_msgs__msg__SuctionGrasp__fini(msg);
    return false;
  }
  // item_uuid
  if (!rosidl_runtime_c__String__init(&msg->item_uuid)) {
    rc_reason_msgs__msg__SuctionGrasp__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__init(&msg->pose)) {
    rc_reason_msgs__msg__SuctionGrasp__fini(msg);
    return false;
  }
  // quality
  // max_suction_surface_length
  // max_suction_surface_width
  return true;
}

void
rc_reason_msgs__msg__SuctionGrasp__fini(rc_reason_msgs__msg__SuctionGrasp * msg)
{
  if (!msg) {
    return;
  }
  // uuid
  rosidl_runtime_c__String__fini(&msg->uuid);
  // item_uuid
  rosidl_runtime_c__String__fini(&msg->item_uuid);
  // pose
  geometry_msgs__msg__PoseStamped__fini(&msg->pose);
  // quality
  // max_suction_surface_length
  // max_suction_surface_width
}

rc_reason_msgs__msg__SuctionGrasp *
rc_reason_msgs__msg__SuctionGrasp__create()
{
  rc_reason_msgs__msg__SuctionGrasp * msg = (rc_reason_msgs__msg__SuctionGrasp *)malloc(sizeof(rc_reason_msgs__msg__SuctionGrasp));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__SuctionGrasp));
  bool success = rc_reason_msgs__msg__SuctionGrasp__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__SuctionGrasp__destroy(rc_reason_msgs__msg__SuctionGrasp * msg)
{
  if (msg) {
    rc_reason_msgs__msg__SuctionGrasp__fini(msg);
  }
  free(msg);
}


bool
rc_reason_msgs__msg__SuctionGrasp__Sequence__init(rc_reason_msgs__msg__SuctionGrasp__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_reason_msgs__msg__SuctionGrasp * data = NULL;
  if (size) {
    data = (rc_reason_msgs__msg__SuctionGrasp *)calloc(size, sizeof(rc_reason_msgs__msg__SuctionGrasp));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__SuctionGrasp__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__SuctionGrasp__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__SuctionGrasp__Sequence__fini(rc_reason_msgs__msg__SuctionGrasp__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__SuctionGrasp__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__SuctionGrasp__Sequence *
rc_reason_msgs__msg__SuctionGrasp__Sequence__create(size_t size)
{
  rc_reason_msgs__msg__SuctionGrasp__Sequence * array = (rc_reason_msgs__msg__SuctionGrasp__Sequence *)malloc(sizeof(rc_reason_msgs__msg__SuctionGrasp__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__SuctionGrasp__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__SuctionGrasp__Sequence__destroy(rc_reason_msgs__msg__SuctionGrasp__Sequence * array)
{
  if (array) {
    rc_reason_msgs__msg__SuctionGrasp__Sequence__fini(array);
  }
  free(array);
}
