// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:srv/ComputeGrasps.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/detail/compute_grasps__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `pose_frame`
// Member `region_of_interest_id`
// Member `load_carrier_id`
#include "rosidl_runtime_c/string_functions.h"
// Member `load_carrier_compartment`
#include "rc_reason_msgs/msg/detail/compartment__functions.h"
// Member `item_models`
#include "rc_reason_msgs/msg/detail/item_model__functions.h"
// Member `robot_pose`
#include "geometry_msgs/msg/detail/pose__functions.h"
// Member `collision_detection`
#include "rc_reason_msgs/msg/detail/collision_detection__functions.h"

bool
rc_reason_msgs__srv__ComputeGrasps_Request__init(rc_reason_msgs__srv__ComputeGrasps_Request * msg)
{
  if (!msg) {
    return false;
  }
  // pose_frame
  if (!rosidl_runtime_c__String__init(&msg->pose_frame)) {
    rc_reason_msgs__srv__ComputeGrasps_Request__fini(msg);
    return false;
  }
  // region_of_interest_id
  if (!rosidl_runtime_c__String__init(&msg->region_of_interest_id)) {
    rc_reason_msgs__srv__ComputeGrasps_Request__fini(msg);
    return false;
  }
  // load_carrier_id
  if (!rosidl_runtime_c__String__init(&msg->load_carrier_id)) {
    rc_reason_msgs__srv__ComputeGrasps_Request__fini(msg);
    return false;
  }
  // load_carrier_compartment
  if (!rc_reason_msgs__msg__Compartment__init(&msg->load_carrier_compartment)) {
    rc_reason_msgs__srv__ComputeGrasps_Request__fini(msg);
    return false;
  }
  // item_models
  if (!rc_reason_msgs__msg__ItemModel__Sequence__init(&msg->item_models, 0)) {
    rc_reason_msgs__srv__ComputeGrasps_Request__fini(msg);
    return false;
  }
  // suction_surface_length
  // suction_surface_width
  // robot_pose
  if (!geometry_msgs__msg__Pose__init(&msg->robot_pose)) {
    rc_reason_msgs__srv__ComputeGrasps_Request__fini(msg);
    return false;
  }
  // collision_detection
  if (!rc_reason_msgs__msg__CollisionDetection__init(&msg->collision_detection)) {
    rc_reason_msgs__srv__ComputeGrasps_Request__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__srv__ComputeGrasps_Request__fini(rc_reason_msgs__srv__ComputeGrasps_Request * msg)
{
  if (!msg) {
    return;
  }
  // pose_frame
  rosidl_runtime_c__String__fini(&msg->pose_frame);
  // region_of_interest_id
  rosidl_runtime_c__String__fini(&msg->region_of_interest_id);
  // load_carrier_id
  rosidl_runtime_c__String__fini(&msg->load_carrier_id);
  // load_carrier_compartment
  rc_reason_msgs__msg__Compartment__fini(&msg->load_carrier_compartment);
  // item_models
  rc_reason_msgs__msg__ItemModel__Sequence__fini(&msg->item_models);
  // suction_surface_length
  // suction_surface_width
  // robot_pose
  geometry_msgs__msg__Pose__fini(&msg->robot_pose);
  // collision_detection
  rc_reason_msgs__msg__CollisionDetection__fini(&msg->collision_detection);
}

rc_reason_msgs__srv__ComputeGrasps_Request *
rc_reason_msgs__srv__ComputeGrasps_Request__create()
{
  rc_reason_msgs__srv__ComputeGrasps_Request * msg = (rc_reason_msgs__srv__ComputeGrasps_Request *)malloc(sizeof(rc_reason_msgs__srv__ComputeGrasps_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__ComputeGrasps_Request));
  bool success = rc_reason_msgs__srv__ComputeGrasps_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__ComputeGrasps_Request__destroy(rc_reason_msgs__srv__ComputeGrasps_Request * msg)
{
  if (msg) {
    rc_reason_msgs__srv__ComputeGrasps_Request__fini(msg);
  }
  free(msg);
}


bool
rc_reason_msgs__srv__ComputeGrasps_Request__Sequence__init(rc_reason_msgs__srv__ComputeGrasps_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_reason_msgs__srv__ComputeGrasps_Request * data = NULL;
  if (size) {
    data = (rc_reason_msgs__srv__ComputeGrasps_Request *)calloc(size, sizeof(rc_reason_msgs__srv__ComputeGrasps_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__ComputeGrasps_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__ComputeGrasps_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__ComputeGrasps_Request__Sequence__fini(rc_reason_msgs__srv__ComputeGrasps_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__ComputeGrasps_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__ComputeGrasps_Request__Sequence *
rc_reason_msgs__srv__ComputeGrasps_Request__Sequence__create(size_t size)
{
  rc_reason_msgs__srv__ComputeGrasps_Request__Sequence * array = (rc_reason_msgs__srv__ComputeGrasps_Request__Sequence *)malloc(sizeof(rc_reason_msgs__srv__ComputeGrasps_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__ComputeGrasps_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__ComputeGrasps_Request__Sequence__destroy(rc_reason_msgs__srv__ComputeGrasps_Request__Sequence * array)
{
  if (array) {
    rc_reason_msgs__srv__ComputeGrasps_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `items`
#include "rc_reason_msgs/msg/detail/item__functions.h"
// Member `load_carriers`
#include "rc_reason_msgs/msg/detail/load_carrier__functions.h"
// Member `grasps`
#include "rc_reason_msgs/msg/detail/suction_grasp__functions.h"
// Member `return_code`
#include "rc_common_msgs/msg/detail/return_code__functions.h"

bool
rc_reason_msgs__srv__ComputeGrasps_Response__init(rc_reason_msgs__srv__ComputeGrasps_Response * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    rc_reason_msgs__srv__ComputeGrasps_Response__fini(msg);
    return false;
  }
  // items
  if (!rc_reason_msgs__msg__Item__Sequence__init(&msg->items, 0)) {
    rc_reason_msgs__srv__ComputeGrasps_Response__fini(msg);
    return false;
  }
  // load_carriers
  if (!rc_reason_msgs__msg__LoadCarrier__Sequence__init(&msg->load_carriers, 0)) {
    rc_reason_msgs__srv__ComputeGrasps_Response__fini(msg);
    return false;
  }
  // grasps
  if (!rc_reason_msgs__msg__SuctionGrasp__Sequence__init(&msg->grasps, 0)) {
    rc_reason_msgs__srv__ComputeGrasps_Response__fini(msg);
    return false;
  }
  // return_code
  if (!rc_common_msgs__msg__ReturnCode__init(&msg->return_code)) {
    rc_reason_msgs__srv__ComputeGrasps_Response__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__srv__ComputeGrasps_Response__fini(rc_reason_msgs__srv__ComputeGrasps_Response * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // items
  rc_reason_msgs__msg__Item__Sequence__fini(&msg->items);
  // load_carriers
  rc_reason_msgs__msg__LoadCarrier__Sequence__fini(&msg->load_carriers);
  // grasps
  rc_reason_msgs__msg__SuctionGrasp__Sequence__fini(&msg->grasps);
  // return_code
  rc_common_msgs__msg__ReturnCode__fini(&msg->return_code);
}

rc_reason_msgs__srv__ComputeGrasps_Response *
rc_reason_msgs__srv__ComputeGrasps_Response__create()
{
  rc_reason_msgs__srv__ComputeGrasps_Response * msg = (rc_reason_msgs__srv__ComputeGrasps_Response *)malloc(sizeof(rc_reason_msgs__srv__ComputeGrasps_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__ComputeGrasps_Response));
  bool success = rc_reason_msgs__srv__ComputeGrasps_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__ComputeGrasps_Response__destroy(rc_reason_msgs__srv__ComputeGrasps_Response * msg)
{
  if (msg) {
    rc_reason_msgs__srv__ComputeGrasps_Response__fini(msg);
  }
  free(msg);
}


bool
rc_reason_msgs__srv__ComputeGrasps_Response__Sequence__init(rc_reason_msgs__srv__ComputeGrasps_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_reason_msgs__srv__ComputeGrasps_Response * data = NULL;
  if (size) {
    data = (rc_reason_msgs__srv__ComputeGrasps_Response *)calloc(size, sizeof(rc_reason_msgs__srv__ComputeGrasps_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__ComputeGrasps_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__ComputeGrasps_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__ComputeGrasps_Response__Sequence__fini(rc_reason_msgs__srv__ComputeGrasps_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__ComputeGrasps_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__ComputeGrasps_Response__Sequence *
rc_reason_msgs__srv__ComputeGrasps_Response__Sequence__create(size_t size)
{
  rc_reason_msgs__srv__ComputeGrasps_Response__Sequence * array = (rc_reason_msgs__srv__ComputeGrasps_Response__Sequence *)malloc(sizeof(rc_reason_msgs__srv__ComputeGrasps_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__ComputeGrasps_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__ComputeGrasps_Response__Sequence__destroy(rc_reason_msgs__srv__ComputeGrasps_Response__Sequence * array)
{
  if (array) {
    rc_reason_msgs__srv__ComputeGrasps_Response__Sequence__fini(array);
  }
  free(array);
}
