// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:msg/DetectedTag.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__DETECTED_TAG__STRUCT_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__DETECTED_TAG__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'tag'
#include "rc_reason_msgs/msg/detail/tag__struct.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__msg__DetectedTag __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__msg__DetectedTag __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DetectedTag_
{
  using Type = DetectedTag_<ContainerAllocator>;

  explicit DetectedTag_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    tag(_init),
    pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->instance_id = "";
    }
  }

  explicit DetectedTag_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    tag(_alloc, _init),
    pose(_alloc, _init),
    instance_id(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->instance_id = "";
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _tag_type =
    rc_reason_msgs::msg::Tag_<ContainerAllocator>;
  _tag_type tag;
  using _pose_type =
    geometry_msgs::msg::PoseStamped_<ContainerAllocator>;
  _pose_type pose;
  using _instance_id_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _instance_id_type instance_id;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__tag(
    const rc_reason_msgs::msg::Tag_<ContainerAllocator> & _arg)
  {
    this->tag = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::PoseStamped_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }
  Type & set__instance_id(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->instance_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::msg::DetectedTag_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::msg::DetectedTag_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::DetectedTag_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::DetectedTag_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::DetectedTag_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::DetectedTag_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::DetectedTag_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::DetectedTag_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::DetectedTag_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::DetectedTag_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__msg__DetectedTag
    std::shared_ptr<rc_reason_msgs::msg::DetectedTag_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__msg__DetectedTag
    std::shared_ptr<rc_reason_msgs::msg::DetectedTag_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DetectedTag_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->tag != other.tag) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    if (this->instance_id != other.instance_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const DetectedTag_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DetectedTag_

// alias to use template instance with default allocator
using DetectedTag =
  rc_reason_msgs::msg::DetectedTag_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__MSG__DETAIL__DETECTED_TAG__STRUCT_HPP_
