// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:msg/ItemModel.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__ITEM_MODEL__STRUCT_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__ITEM_MODEL__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'unknown'
#include "rc_reason_msgs/msg/detail/range_box__struct.hpp"
// Member 'rectangle'
#include "rc_reason_msgs/msg/detail/range_rectangle__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__msg__ItemModel __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__msg__ItemModel __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ItemModel_
{
  using Type = ItemModel_<ContainerAllocator>;

  explicit ItemModel_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : unknown(_init),
    rectangle(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->type = "";
    }
  }

  explicit ItemModel_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : type(_alloc),
    unknown(_alloc, _init),
    rectangle(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->type = "";
    }
  }

  // field types and members
  using _type_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _type_type type;
  using _unknown_type =
    rc_reason_msgs::msg::RangeBox_<ContainerAllocator>;
  _unknown_type unknown;
  using _rectangle_type =
    rc_reason_msgs::msg::RangeRectangle_<ContainerAllocator>;
  _rectangle_type rectangle;

  // setters for named parameter idiom
  Type & set__type(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__unknown(
    const rc_reason_msgs::msg::RangeBox_<ContainerAllocator> & _arg)
  {
    this->unknown = _arg;
    return *this;
  }
  Type & set__rectangle(
    const rc_reason_msgs::msg::RangeRectangle_<ContainerAllocator> & _arg)
  {
    this->rectangle = _arg;
    return *this;
  }

  // constant declarations
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> UNKNOWN;
  static const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> RECTANGLE;

  // pointer types
  using RawPtr =
    rc_reason_msgs::msg::ItemModel_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::msg::ItemModel_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::ItemModel_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::ItemModel_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::ItemModel_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::ItemModel_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::ItemModel_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::ItemModel_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::ItemModel_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::ItemModel_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__msg__ItemModel
    std::shared_ptr<rc_reason_msgs::msg::ItemModel_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__msg__ItemModel
    std::shared_ptr<rc_reason_msgs::msg::ItemModel_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ItemModel_ & other) const
  {
    if (this->type != other.type) {
      return false;
    }
    if (this->unknown != other.unknown) {
      return false;
    }
    if (this->rectangle != other.rectangle) {
      return false;
    }
    return true;
  }
  bool operator!=(const ItemModel_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ItemModel_

// alias to use template instance with default allocator
using ItemModel =
  rc_reason_msgs::msg::ItemModel_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
ItemModel_<ContainerAllocator>::UNKNOWN = "UNKNOWN";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>
ItemModel_<ContainerAllocator>::RECTANGLE = "RECTANGLE";

}  // namespace msg

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__MSG__DETAIL__ITEM_MODEL__STRUCT_HPP_
