// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/LoadCarrierWithFillingLevel.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/load_carrier_with_filling_level__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `id`
#include "rosidl_runtime_c/string_functions.h"
// Member `outer_dimensions`
// Member `inner_dimensions`
#include "rc_reason_msgs/msg/detail/box__functions.h"
// Member `rim_thickness`
#include "rc_reason_msgs/msg/detail/rectangle__functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose_stamped__functions.h"
// Member `overall_filling_level`
// Member `cells_filling_levels`
#include "rc_reason_msgs/msg/detail/cell_filling_level__functions.h"
// Member `filling_level_cell_count`
#include "rc_reason_msgs/msg/detail/grid_size__functions.h"

bool
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__init(rc_reason_msgs__msg__LoadCarrierWithFillingLevel * msg)
{
  if (!msg) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__init(&msg->id)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // outer_dimensions
  if (!rc_reason_msgs__msg__Box__init(&msg->outer_dimensions)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // inner_dimensions
  if (!rc_reason_msgs__msg__Box__init(&msg->inner_dimensions)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // rim_thickness
  if (!rc_reason_msgs__msg__Rectangle__init(&msg->rim_thickness)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__init(&msg->pose)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // overfilled
  // overall_filling_level
  if (!rc_reason_msgs__msg__CellFillingLevel__init(&msg->overall_filling_level)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // cells_filling_levels
  if (!rc_reason_msgs__msg__CellFillingLevel__Sequence__init(&msg->cells_filling_levels, 0)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // filling_level_cell_count
  if (!rc_reason_msgs__msg__GridSize__init(&msg->filling_level_cell_count)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(rc_reason_msgs__msg__LoadCarrierWithFillingLevel * msg)
{
  if (!msg) {
    return;
  }
  // id
  rosidl_runtime_c__String__fini(&msg->id);
  // outer_dimensions
  rc_reason_msgs__msg__Box__fini(&msg->outer_dimensions);
  // inner_dimensions
  rc_reason_msgs__msg__Box__fini(&msg->inner_dimensions);
  // rim_thickness
  rc_reason_msgs__msg__Rectangle__fini(&msg->rim_thickness);
  // pose
  geometry_msgs__msg__PoseStamped__fini(&msg->pose);
  // overfilled
  // overall_filling_level
  rc_reason_msgs__msg__CellFillingLevel__fini(&msg->overall_filling_level);
  // cells_filling_levels
  rc_reason_msgs__msg__CellFillingLevel__Sequence__fini(&msg->cells_filling_levels);
  // filling_level_cell_count
  rc_reason_msgs__msg__GridSize__fini(&msg->filling_level_cell_count);
}

rc_reason_msgs__msg__LoadCarrierWithFillingLevel *
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__create()
{
  rc_reason_msgs__msg__LoadCarrierWithFillingLevel * msg = (rc_reason_msgs__msg__LoadCarrierWithFillingLevel *)malloc(sizeof(rc_reason_msgs__msg__LoadCarrierWithFillingLevel));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__LoadCarrierWithFillingLevel));
  bool success = rc_reason_msgs__msg__LoadCarrierWithFillingLevel__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__destroy(rc_reason_msgs__msg__LoadCarrierWithFillingLevel * msg)
{
  if (msg) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
  }
  free(msg);
}


bool
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__init(rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_reason_msgs__msg__LoadCarrierWithFillingLevel * data = NULL;
  if (size) {
    data = (rc_reason_msgs__msg__LoadCarrierWithFillingLevel *)calloc(size, sizeof(rc_reason_msgs__msg__LoadCarrierWithFillingLevel));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__LoadCarrierWithFillingLevel__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__fini(rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence *
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__create(size_t size)
{
  rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence * array = (rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence *)malloc(sizeof(rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__destroy(rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence * array)
{
  if (array) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__fini(array);
  }
  free(array);
}
